// bytran -|- spectral calculations for portable devices using the HITRAN database
//
// Developed by Dzianis Pliutau (Denis Plutov) and Kostya Roslyakov
// www.bytran.org | contact@bytran.org
// Copyright (c) 2016 Dzianis Pliutau
// Distributed under the MIT license
//
// The MIT License (MIT)
// Copyright (c) 2016 Dzianis Pliutau
//
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,
// modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software
// is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR
// IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.



// Object contains information about the currently active pathlength units and performs the conversion from / to the default pathlenth units from the currently active ones
#include "pathlengthunitsconvert.h"

PathlengthUnitsConvert::PathlengthUnitsConvert()
{

}

// Method to get and set the current total pressure units
int PathlengthUnitsConvert::getUnits() { return this->currentUnits; }
void PathlengthUnitsConvert::setUnits(int newUnits) { this->currentUnits = newUnits; }

// Method to convert from default units to current units
double PathlengthUnitsConvert::fromDefaultToCurrent(double defaultValue)
{
    // 0 - Kilometers, km;  1 - Meters, m;  2 - Centimeters, cm;  3 - Miles, mi";  4 - Feet, ft;  5 - Inches, in
    switch (currentUnits)
    {
        case 0:
            return defaultValue * 0.001;
            break;
        case 1:
            return defaultValue;
            break;
        case 2:
            return defaultValue * 100;
            break;
        case 3:
            return defaultValue * 0.0006213712;
            break;
        case 4:
            return defaultValue * 3.2808398950131233595800524934383;
            break;
        case 5:
            return defaultValue * 39.37008;
            break;
        default:
            return defaultValue;
            break;
    }
}

// Method to convert from the current units to the default units
double PathlengthUnitsConvert::fromCurrentToDefault(double currentValue)
{
    // 0 - Kilometers, km;  1 - Meters, m;  2 - Centimeters, cm;  3 - Miles, mi";  4 - Feet, ft;  5 - Inches, in
    switch (currentUnits)
    {
        case 0:
            return currentValue * 1000;
            break;
        case 1:
            return currentValue;
            break;
        case 2:
            return currentValue * 0.01;
            break;
        case 3:
            return currentValue * 1609.344;
            break;
        case 4:
            return currentValue * 0.3048;
            break;
        case 5:
            return currentValue * 0.0254;
            break;
        default:
            return currentValue;
            break;
    }
}
